import type { FormProps, FormItemRule } from 'element-plus'

export type formSlot = {
  name: string
  alias: string
}

export type BasicFormItem = {
  label: string
  value: any
  name: string
  type: string
  placeholder?: string
  children?: Array<BasicFormItem>
  options?: Array<any>
  search?: boolean
  required?: boolean
  rules?: FormItemRule | FormItemRule[]
  span?: number
  props?: object
  events?: object
  request?: Function
  slots?: Array<formSlot>
}

export type AdvancedFormItem = {
  label: string
  group: BasicFormItem[]
}

type Form = {
  props?: Partial<FormProps>
  route?: any
  span?: number
  advanced?: boolean
}

export type BasicForm = Form & {
  formItems: BasicFormItem[]
}

export type AdvancedForm = Form & {
  formItems: AdvancedFormItem[]
}

export interface ICRUD {
  create: Function
  update: Function
  delete: Function
  deleteBatch?: Function
  getList: Function
  getRecord?: Function
}
